# std::is_polymorphic

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct is_polymorphic; |  | (since C++11)

If `T` is a polymorphic class (that is, a non-union class that declares or inherits at least one virtual function), provides the member constant `value` equal true. For any other type, `value` is false.

If `T` is a non-union class type, `T` shall be a complete type; otherwise, the behavior is undefined.

### Template parameters

T | - | a type to check

### Helper variable template

template< class T > inline constexpr bool is_polymorphic_v = is_polymorphic<T>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | true if `T` is a polymorphic class type , false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant <bool, value>

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    struct A {
        int m;
    };

    struct B {
        virtual void foo();
    };

    struct C : B {};

    int main()
    {
        std::cout << std::boolalpha;
        std::cout << std::is_polymorphic<A>::value << '\n';
        std::cout << std::is_polymorphic<B>::value << '\n';
        std::cout << std::is_polymorphic<C>::value << '\n';
    }

Output:

    false
    true
    true

### See also

is_class (C++11) | checks if a type is a non-union class type (class template)
is_abstract (C++11) | checks if a type is an abstract class type (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/types/is_polymorphic&oldid=90986"